package dev.fitko.fitconnect.core.http;

import dev.fitko.fitconnect.api.config.BuildInfo;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertTrue;

class RestServiceTest {

    RestService underTest;

    @Test
    void proxyRestTemplate() {

        // Given
        underTest = new RestService("http://testhost.de", 8080, new BuildInfo());

        // When
        final HttpClient httpClient = underTest.getHttpClient();

        // Then
        assertNotNull(httpClient);
    }

    @Test
    void hasProxySet() {

        // Given
        underTest = new RestService("http://testhost.de", 8080, new BuildInfo());

        // When
        final boolean proxySet = underTest.hasProxySet();

        // Then
        assertTrue(proxySet);
    }

    @Test
    void hasProxyNotSet() {

        // Given
        underTest = new RestService(null, 0, new BuildInfo());

        // When
        final boolean proxySet = underTest.hasProxySet();

        // Then
        assertFalse(proxySet);
    }

    @Test
    void testToString() {

        // Given
        underTest = new RestService("http://testhost.de", 8080, new BuildInfo());

        // When
        final String configAsString = underTest.toString();

        // Then
        assertEquals("ProxyConfig {host='http://testhost.de', port=8080}", configAsString);
    }
}